#
# FILE            $Id: RemoteCalldefs.py,v 1.1 1995/07/06 18:25:04 omfadmin Exp $
#
# DESCRIPTION     Definitions common for RemoteCall and RemoteCallServer
#
# AUTHOR          SEISY/LKSB Daniel Larsson
#
# All rights reserved. Reproduction, modification, use or disclosure
# to third parties without express authority is forbidden.
# Copyright ABB Industrial Systems AB, Sweden, 1994.
#
# HISTORY:
#
# $Log: RemoteCalldefs.py,v $
# Revision 1.1  1995/07/06  18:25:04  omfadmin
# Initial revision
#
# Revision 1.3  1995/03/13  16:03:48  dlarsson
# Removed support for recording (didn't work well with new Agent
# support). Other updates suggested by Guido.
#
# Revision 1.2  1995/03/13  12:45:36  dlarsson
# Now using pickle module.
#
# Revision 1.1  1995/01/12  16:38:31  dlarsson
# Initial revision
#
#
# ABSTRACT
#
#*/

# Mode to execute request in on server side
EXEC   = 0
EVAL   = 1
CALL   = 2
SETATTR= 3

def picklify(objs):
	from StringIO import StringIO
	from pickle import Pickler
	sio = StringIO()
	pickler = Pickler(sio)
	pickler.dump(objs)
	return sio.getvalue()

def unpicklify(pickled_objs):
	from StringIO import StringIO
	from pickle import Unpickler
	sio = StringIO(pickled_objs)
	unp = Unpickler(sio)
	return unp.load()
